local BH = ByeHakmud

SLASH_BYEHAKMUD1 = '/ByeHakmud';
function SlashCmdList.BYEHAKMUD(msg, editbox)
	local function addTarget(permission)
	    local presetName = BH:DetectSituation();
	    if (presetName) then
		local targetName = BH:AddTargetAsPermission(permission, presetName)
		if (targetName) then 
		    BH:PostMessage(
		      TL("ByeHakmud added a rule for") .. " \"" .. tostring(targetName) .. "\" " ..
		      TL("to preset") .. " \"" .. tostring(presetName) .. "\""
		    )
		else 
		    BH:PostMessage(TL("ByeHakmud can not add a rule for an empty target."))
		end
	    else 
		BH:PostMessage(TL("ByeHakmud failed to add a rule because no preset applies to the current situation."))
	    end
	end
	
	local cmd, param = string.match(msg, "(%a+)%s*(.*)")
	cmd = string.lower(cmd or "")
	if cmd == 'gui' then
		InterfaceOptionsFrame_OpenToCategory(ByeHakmudConfigFrame);
		-- Call it twice because due to a bug in blizzards code the 
		-- options window is opened but ByeHakmudConfigFrame is not
		-- activated. The 2nd call may be removed when blizzards code 
		-- is fixed. (not yet fixed int WoW 5.4.2)
		InterfaceOptionsFrame_OpenToCategory(ByeHakmudConfigFrame);
	elseif cmd == 'allowtarget' then
		addTarget("Allow")
	elseif cmd == 'denytarget' then
		addTarget("Deny")
	else
		BH:PostMessage(
			"ByeHakmud Version: " .. BH.Vars:GetVersion() .. " " .. BH.Vars:GetAddonUrl() .."\n" ..
			TL("/ByeHakmud gui -- show configuration panel") .. "\n" ..
			TL("/ByeHakmud allowtarget -- adds a rule for the target to the preset currently in effect") .. "\n" ..
			TL("/ByeHakmud denytarget -- adds a rule for the target to the preset currently in effect")
		);
	end
end
